<?php
/**
  * Update m2f database schema to version 10
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version
  * @internal
*/



function m2f_update_schema_10($type_db)
{
	global $m2f_db;
 	m2f_log(PEAR_LOG_NOTICE , "Updating M2F tables to DB version 10" , __LINE__ , __FILE__);


	// Update pattern target value to conform to new bitwise value
	$sql = 'SELECT pattern_id, target
						FROM ' . _M2F_PATTERN_MATCH_TABLE_;
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	foreach ($db_result as $pattern)
	{
		if (is_numeric($pattern['target'])) continue;
		$sql = 'UPDATE ' . _M2F_PATTERN_MATCH_TABLE_ . '
							SET target = \'';
		switch ($pattern['target'])
		{
			case 'Subject':
				$sql .= '1';
				break;
			case 'Body':
				$sql .= '2';
				break;
			case 'Subject & Body':
				$sql .= '3';
				break;
		}
		$sql .= '\' WHERE pattern_id = \'' . $pattern['pattern_id'] . '\'';
		$db_result = $m2f_db->query($sql);
		check_db_result($db_result, $sql, __LINE__, __FILE__);
	}

	// Update version number
	$sql = "UPDATE " . _M2F_CONFIG_TABLE_ . "
	     		SET config_value = 10
	     		WHERE config_name = '_M2F_DB_VERSION_'";
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	m2f_log(PEAR_LOG_NOTICE , "Updated DB version to 10" , __LINE__ , __FILE__ );


	return TRUE;
}

?>