<?php

function date_select ($set_day, $set_month, $set_year, $set_hour, $set_minute, $option_tag) 
{
	$months = array(1 => 'January', 2 => 'February', 3 => 'March', 4 => 'April', 5 => 'May', 6 => 'June', 7 => 'July', 8 => 'August', 9 => 'September', 10 => 'October', 11 => 'November', 12 => 'December');
	$date_select = '<select name="day' . $option_tag . '">';
	for ($day=1; $day<32; $day++)
	{
		$date_select .= '<option value="' . sprintf("%02d", $day) . '"';
		if ($day == $set_day) $date_select .= ' selected="selected"';
		$date_select .= '>' . $day . '</option>';
	}
	$date_select .= '</select>
		<select name="month' . $option_tag . '">';
	for ($month=1; $month<13; $month++)
	{
		$date_select .= '<option value="' . sprintf("%02d", $month) . '"';
		if ($month == $set_month) $date_select .= ' selected="selected"';
		$date_select .= '>' . $months[$month] . '</option>';
	}
	$date_select .= '</select>
		<select name="year' . $option_tag . '">';
	for ($year=2000; $year<2011; $year++)
	{
		$date_select .= '<option value="' . $year . '"';
		if ($year == $set_year) $date_select .= ' selected="selected"';
		$date_select .= '>' . $year . '</option>';
	}
	$date_select .= '</select>';
		
	$date_select .= '
		&nbsp;&nbsp;<select name="hour' . $option_tag . '">';
	for ($hour=00; $hour<24; $hour++)
	{
		$date_select .= '<option value="' . sprintf("%02d", $hour) . '"';
		if ($hour == $set_hour) $date_select .= ' selected="selected"';
		$date_select .= '>' . sprintf("%02d", $hour) . '</option>';
	}

	$date_select .= '</select><select name="minute' . $option_tag . '">';
	for ($minute=00; $minute<60; $minute++) 
	{
		$date_select .= '<option value="' . sprintf("%02d", $minute) . '"';
		if ($minute == $set_minute) $date_select .= ' selected="selected"';
		$date_select .= '>' . sprintf("%02d", $minute) . '</option>';
	}
	$date_select .= '</select><br /><br />';
		
	return $date_select;
}



function do_subscriptions_action($action) {
	global $m2f_handler;
	$error = NULL;
	switch ($action)
	{
		case 'Unsubscribe user':
			if (!empty($_POST['user_id'])) $result = $m2f_handler->m2f_mailinglist->delete_subscription($_POST['mailinglist_id'] , $_POST['user_id']);
			else if (!empty($_POST['username'])) $result = $m2f_handler->m2f_mailinglist->delete_subscription_by_username($_POST['mailinglist_id'] , $_POST['username']);
			if ($result === FALSE) $error = 'Username not found';
		break;
		
		case 'Subscribe user':
			if (!empty($_POST['username'])) $result = $m2f_handler->m2f_mailinglist->new_subscription_by_username($_POST['mailinglist_id'], $_POST['username']);
			if ($result === FALSE) $error = 'Username not found';
		break;
		
		case 'Delete all subscriptions':
			$m2f_handler->m2f_mailinglist->delete_all_subscriptions($_POST['mailinglist_id']);
		break;

		case 'Subscribe current board members':
			$m2f_handler->m2f_mailinglist->set_whole_board_subscription($_POST['mailinglist_id']);
		break;
		
		case 'Subscribe Group':
			$m2f_handler->m2f_mailinglist->subscribe_group($_POST['group_id'], $_POST['mailinglist_id']);
		break;
		
		case 'Unsubscribe Group':
			$m2f_handler->m2f_mailinglist->unsubscribe_group($_POST['group_id'], $_POST['mailinglist_id']);
		break;
		
		case 'Subscribe whole board':
			$m2f_handler->m2f_mailinglist->set_board_subscription($_POST['mailinglist_id'], 1);
		break;
		
		case 'Unsubscribe whole board':
			$m2f_handler->m2f_mailinglist->set_board_subscription($_POST['mailinglist_id'], 0);
		break;
	}
	return $error;
}

function do_mailinglist_action($action) {
	global $m2f_handler;
	switch ($_POST['action'])
	{
		case 'Add':
			if (empty($_POST['ml_name']) || empty($_POST['list_email'])) break;
			$new_mailinglist_id = $m2f_handler->m2f_mailinglist->new_mailinglist(array("name" => $_POST['ml_name'], "list_email" => $_POST['list_email']));
		break;

		case 'Edit':
			if (isset($_POST['edited'])) $m2f_handler->m2f_mailinglist->edit_mailinglist($_POST['mailinglist_id'], $_POST['ml_name'], $_POST['list_email']);
		break;
		
		case 'Delete':
			$m2f_handler->m2f_mailinglist->delete_mailinglist($_POST['mailinglist_id']);
		break;
	}
}


function get_mailinglists() {
	global $m2f_handler;
	$mailinglists = $m2f_handler->get_mailinglists();
	foreach ($mailinglists as $mailinglist_id => $list)
	{
		$list['num_subscriptions'] = $m2f_handler->m2f_mailinglist->count_subscriptions($mailinglist_id);
		$list['num_group_subscriptions'] = $m2f_handler->m2f_mailinglist->count_group_subscriptions($mailinglist_id);
		$list['board_subscribed'] = $m2f_handler->m2f_mailinglist->is_board_subscribed($mailinglist_id);
		$mailinglists[$mailinglist_id] = $list;
	}
	return $mailinglists;
}


function get_email_subscriptions_info($mailinglist_id) {
	global $m2f_handler;
	return $m2f_handler->m2f_mailinglist->get_subscriptions($mailinglist_id);
}


function get_subscriptions_info($mailinglist_id) {
	global $m2f_handler;
	
	$select_list = '';
	$subscribed_groups = array();
	$groups = $m2f_handler->m2f_mailinglist->get_subscribed_groups($mailinglist_id);

	foreach ($groups as $group)
	{
		if (empty($group['mailinglist_id'])) $unsubscribed_groups[] = array('group_id' => $group['group_id'], 'group_name' => $group['group_name']);
		else $subscribed_groups[] = array('group_id' => $group['group_id'], 'group_name' => $group['group_name']);
	}

	if (!empty($unsubscribed_groups))
	{
		if (count($unsubscribed_groups))
		{
			$select_list .= '<select name="group_id">';
			foreach ($unsubscribed_groups as $group)
			{
				$select_list .= '<option value="' . $group['group_id'] . '">' . $group['group_name'] . '</option>';
			}
			$select_list .= '</select>';
		}
	}
	
	$num_subscriptions = $m2f_handler->m2f_mailinglist->count_subscriptions($mailinglist_id);
	$num_subscriptions_phrase = ($num_subscriptions == 1) ? 'There is currently 1 user subscribed' : 'There are currently ' . $num_subscriptions . ' users subscribed';
	$is_board_subscribed = $m2f_handler->m2f_mailinglist->is_board_subscribed($mailinglist_id);
	$ml_name = $m2f_handler->m2f_mailinglist->get_mailinglist_name($mailinglist_id);
	
	return array($select_list, $subscribed_groups, $num_subscriptions_phrase, $is_board_subscribed, $ml_name);
}

function configure_dist_list() {
	global $m2f_handler;
	
	$params = array(
	'_M2F_MAIL_BACKEND_' => $_POST['_M2F_MAIL_BACKEND_'],
	'_M2F_INPUT_BACKEND_' => $_POST['_M2F_INPUT_BACKEND_'],
	'_M2F_SMTP_HOST_' => $_POST['_M2F_SMTP_HOST_'],
	'_M2F_SMTP_PORT_' => $_POST['_M2F_SMTP_PORT_'],
	'_M2F_SMTP_AUTH_' => ($_POST['_M2F_SMTP_AUTH_'] == '1' ? '1' : '0'),
	'_M2F_SMTP_USERNAME_' => $_POST['_M2F_SMTP_USERNAME_'],
	'_M2F_SMTP_PASSWORD_' => $_POST['_M2F_SMTP_PASSWORD_'],
	'_M2F_MBOX_FILE_' => $_POST['_M2F_MBOX_FILE_'],
	'_M2F_POP3_HOST_' => $_POST['_M2F_POP3_HOST_'],
	'_M2F_POP3_PORT_' => $_POST['_M2F_POP3_PORT_'],
	'_M2F_POP3_USER_' => $_POST['_M2F_POP3_USER_'],
	'_M2F_POP3_PASS_' => $_POST['_M2F_POP3_PASS_'],
	'_M2F_POP3_APOP_' => $_POST['_M2F_POP3_APOP_'],
	'_M2F_GMAIL_USERNAME_' => $_POST['_M2F_GMAIL_USERNAME_'],
	'_M2F_GMAIL_PASSWORD_' => $_POST['_M2F_GMAIL_PASSWORD_'],
	'_M2F_MAX_MSG_RETRIEVE_' => $_POST['_M2F_MAX_MSG_RETRIEVE_'],
	'_M2F_MAX_MESSAGE_SIZE_' => $_POST['_M2F_MAX_MESSAGE_SIZE_'],
	'_M2F_EXTRACT_MAIL_DATES_' => ($_POST['_M2F_EXTRACT_MAIL_DATES_'] == '1' ? '1' : '0'),
	'_M2F_IGNORE_TO_HEADER_' => ($_POST['_M2F_IGNORE_TO_HEADER_'] == '1' ? '1' : '0'),
	'_M2F_NO_REPLYTO_RECP_' => ($_POST['_M2F_NO_REPLYTO_RECP_'] == '1' ? '1' : '0'),
	'_M2F_REPLY_PREFIXES_' => explode(',' , $_POST['_M2F_REPLY_PREFIXES_LIST_']),
	'_M2F_SUBJECT_PREFIX_' => $_POST['_M2F_SUBJECT_PREFIX_'],
	'_M2F_EXTERNAL_LIST_SERVER_' => ($_POST['_M2F_EXTERNAL_LIST_SERVER_'] == '1' ? '1' : '0'),
	'_M2F_ADD_AUTHOR_AS_RECIPIENT_' => ($_POST['_M2F_ADD_AUTHOR_AS_RECIPIENT_'] == '1' ? '1' : '0'),
	'_M2F_MODERATED_LIST_IN_' => ($_POST['_M2F_MODERATED_LIST_IN_'] == '1' ? '1' : '0'),
	'_M2F_MODERATED_LIST_OUT_' => ($_POST['_M2F_MODERATED_LIST_OUT_'] == '1' ? '1' : '0'),
	'_M2F_MODERATOR_NOTIFY_EMAIL_' => $_POST['_M2F_MODERATOR_NOTIFY_EMAIL_'],
	'_M2F_MODERATOR_NOTIFY_' => $_POST['_M2F_MODERATOR_NOTIFY_'],
	'_M2F_MODERATOR_IGNORE_ADMIN_' => ($_POST['_M2F_MODERATOR_IGNORE_ADMIN_'] == '1' ? '1' : '0'),
	'_M2F_FROM_FIELD_' => $_POST['_M2F_FROM_FIELD_'],
	'_M2F_FROM_OTHER_ADDRESS_' => $_POST['_M2F_FROM_OTHER_ADDRESS_'],
	'_M2F_ALLOW_GUEST_POSTING_' => $_POST['_M2F_ALLOW_GUEST_POSTING_'],
	'_M2F_FORCE_GUEST_POSTING_' => ($_POST['_M2F_FORCE_GUEST_POSTING_'] == '1' ? '1' : '0'),
	'_M2F_IGNORE_SECURITY_SETTINGS_' => ($_POST['_M2F_IGNORE_SECURITY_SETTINGS_'] == '1' ? '1' : '0'),
	'_M2F_SHOW_GUEST_EMAIL_' => $_POST['_M2F_SHOW_GUEST_EMAIL_'],
	'_M2F_DISALLOW_GUEST_ACTION_' => $_POST['_M2F_DISALLOW_GUEST_ACTION_'],
	'_M2F_ADMIN_EMAIL_ADDRESS_' => $_POST['_M2F_ADMIN_EMAIL_ADDRESS_'],
	'_M2F_BOUNCE_INCLUDE_LINK_' => ($_POST['_M2F_BOUNCE_INCLUDE_LINK_'] == '1' ? '1' : '0'),
	'_M2F_RESEND_EDITED_POST_' => ($_POST['_M2F_RESEND_EDITED_POST_'] == '1' ? '1' : '0'),
	'_M2F_ADD_SUBJECT_TAG_EDITED_POST_' => $_POST['_M2F_ADD_SUBJECT_TAG_EDITED_POST_'],
	'_M2F_ADD_BODY_TAG_EDITED_POST_' => $_POST['_M2F_ADD_BODY_TAG_EDITED_POST_'],
	'_M2F_DELETE_IMPORTED_MESSAGES_' => ($_POST['_M2F_DELETE_IMPORTED_MESSAGES_'] == '1' ? '1' : '0'),
	);
	
	$m2f_handler->configure_distributionlist($_POST['distributionlist_id'], $params);
}
	



function test_smtp() {

	$smtp_host = $_POST['_M2F_SMTP_HOST_'];
	$smtp_port = $_POST['_M2F_SMTP_PORT_'];
	$smtp_auth = ($_POST['_M2F_SMTP_AUTH_'] == 1 ? 1 : 0);
	$smtp_username = $_POST['_M2F_SMTP_USERNAME_'];
	$smtp_password = $_POST['_M2F_SMTP_PASSWORD_'];
	$success = TRUE;
	
	include_once 'Net/SMTP.php';

	$smtp = new Net_SMTP($smtp_host, $smtp_port);
	$smtp->setDebug(TRUE);
	ob_start();


	if (PEAR::isError($error = $smtp->connect())) 
	{ 
		$smtp_results .= 'Unable to connect to SMTP server at ' . $smtp_host . ':' . $smtp_port . '<br><span class="code">' . $error->getMessage() . '</span><br />'; 
		$success = FALSE;
	}
	else
	{
		$smtp_results .= 'SMTP server connect was OK<br />';
	}

	if ($smtp_auth) 
	{
		$method = is_string($smtp_auth) ? $smtp_auth : '';

		if (PEAR::isError($error = $smtp->auth($smtp_username, $smtp_password, $method))) 
		{
			$smtp_results .= 'Unable to authenticate to SMTP server with username/password<br><span class="code">' . $error->getMessage() . '</span><br />';
			$success = FALSE;
		}
		else
		{
			$smtp_results .= 'SMTP server login was OK<br />';
		}
	}
	

	@$smtp->disconnect();
  if (!success) $transcript = ob_get_contents();
  ob_end_clean();

	if ($success)
	{
		$params = array();
		$params["host"] = $smtp_host;
		$params["port"] = $smtp_port;
		$params["auth"] = $smtp_auth;
		$params["username"] = $smtp_username;
		$params["password"] = $smtp_password;
		$params["debug"] = TRUE;
	
		ob_start();
		$mail =& Mail::Factory('smtp', $params);
		$headers = array('From' => 'test@example.com', 'To' => 'mail@example.com');
		$send = $mail->send('mail@example.com' , $headers, 'test');
		$send_debug_session = ob_get_contents();
		ob_end_clean();
		
		if (PEAR::isError($send)) 
		{
			$smtp_results .= 'Error sending SMTP test email.<br />
												<small>This is a test to see if your SMTP server allows the "FROM" header of an email to be set to <i>any address</i>. 
												As your server does not allow this, you will have to configure the <i>From field</i> setting (below) to send email from 
												the correct address for this SMTP account only. The transcript below may state what this address should be.</small><br />';
			$error = $send->getMessage();
			$success = FALSE;
		}
		else
		{
			$smtp_results .= 'Test mail sent succesfully to mail@example.com (blackhole)';
		}
	}
	
	$transcript = empty($transcript) ? (empty($send_debug_session) ? '' : $send_debug_session) : $transcript;
  if (!$success && $transcript ) $smtp_results .= 'Transcript:<br><div class="code">' . nl2br(htmlentities(wordwrap($transcript, 70, "\n", TRUE))) . '</div><br />';

	return array($success, $smtp_results);
}
	
	
	
	
function test_mbox() {
	
	$mbox_path = $_POST['_M2F_MBOX_FILE_'];
	$success = TRUE;
	if (!(@$mbox = fopen($mbox_path, "r")))
	{
		$mbox_results .= 'Mbox path not valid' . (isset($php_errormsg) ? '<br><span class="code">' . $php_errormsg . '</span>' : '') . '<br />';
		$success = FALSE;
	}
	else
	{
		fclose($mbox);
		$mbox_results .= 'Mbox path is OK<br />';
	}
	return array($success, $mbox_results);
}


function test_pop() {

	$pop_host = $_POST['_M2F_POP3_HOST_'];
	$pop_port = $_POST['_M2F_POP3_PORT_'];
	$pop_username = $_POST['_M2F_POP3_USER_'];
	$pop_password = $_POST['_M2F_POP3_PASS_'];
	$pop_apop = $_POST['_M2F_POP3_APOP_'];
	$success = TRUE;

	include_once 'Net/POP3.php';
	$pop = new Net_POP3();
	$pop->setDebug();
	ob_start();

	if (PEAR::isError($connect = $pop->connect($pop_host, $pop_port)))
	{
		$pop_results .= 'Unable to connect to POP3 server at ' . $pop_host . ':' . $pop_port . '<br><div class="code">' . $connect->getMessage() . '</div><br />';
		$success = FALSE;
	}   
	else
	{
		$pop_results .= 'POP server connect was OK<br />';
	}
	
	if (PEAR::isError($login = $pop->login($pop_username, $pop_password, ($pop_apop == '1' ? 'APOP' : 'USER')))) 
	{
	  $pop_results .= 'Unable to log in to POP3 server with username/password<br><div class="code">' . $login->getMessage() . '</div><br />';
		$success = FALSE;
	}
	else
	{
		$pop_results .= 'POP server login was OK<br />';
	}
			
	@$pop->disconnect();
	
  $debug_session = ob_get_contents();
  ob_end_clean();
  if (!$success && !empty($debug_session)) $pop_results .= 'Transcript:<br><div class="code">' . nl2br(htmlentities($debug_session)) . '</div><br />';

	return array($success, $pop_results);
}

function test_gmail() 
{
	global $m2f_root_path;
	include_once ($m2f_root_path.'includes/libgmailer.php');

	$username = $_POST['_M2F_GMAIL_USERNAME_'];
	$password = $_POST['_M2F_GMAIL_PASSWORD_'];
	$my_timezone = 0;
	$box = 'inbox';
	$success = TRUE;
	$gmail_results = '';

	ob_start();

	$gmail = new GMailer();
	if ($gmail->created) 
	{
		$gmail->setLoginInfo($username, $password, $my_timezone);
		$gmail_results .= 'gMail connection created successfully<br />';
		if ($gmail->connectNoCookie()) 
		{
			$gmail_results .= 'gMail account login was OK<br />';
		} 
		else 
		{
			$gmail_results .= 'Unable to log in to gMail account using "' . $username . '" and "' . $password . '"<br><div class="code">' . $gmail->lastActionStatus() . '</div><br />';
			$success = FALSE;
		}
	} 
	else 
	{
		$gmail_results .= 'Unable to create gMail connection<br><span class="code">' . $gmail->lastActionStatus() . '</span><br />';
		$success = FALSE;
	}

	@$gmail->disconnect();
  
  $debug_session = ob_get_contents();
  ob_end_clean();
  if (!empty($debug_session)) $gmail_results .= 'Transcript:<br><span class="code">' . $debug_session . '</span><br />';

	return array($success, $gmail_results);
}

function test_sendmail() {
	global $m2f_db;

	if (isset($_POST['_M2F_SENDMAIL_PATH_']))
	{
		$path = $_POST['_M2F_SENDMAIL_PATH_'];
	}
	else
	{
		$sql = 'SELECT config_value from ' . _M2F_CONFIG_TABLE_ . ' WHERE config_name = \'_M2F_SENDMAIL_PATH_\'';
		$path = $m2f_db->getOne($sql);
		check_db_result($path, $sql, __LINE__, __FILE__);
	}
	return @is_file($path);
}


function get_dist_list_settings() {	
	global $m2f_handler, $mode;
	
	$distributionlist_id = ($mode == 'default_distribution') ? 0 : $_POST['distributionlist_id'];
	
	// Get configs
	$text_params = $m2f_handler->get_distributionlist_configuration($distributionlist_id);

	foreach ($text_params as $param => $config)
	{
		if (is_array($config))
		{
			$text_params[$param.'LIST_'] = implode(',', $config);
		}
	}
	
	$text_params['_M2F_MODERATOR_NOTIFY_EMAIL_'] = htmlentities($text_params['_M2F_MODERATOR_NOTIFY_EMAIL_']);
	$text_params['_M2F_FROM_OTHER_ADDRESS_'] = htmlentities($text_params['_M2F_FROM_OTHER_ADDRESS_']);
	$text_params['_M2F_ADMIN_EMAIL_ADDRESS_'] = htmlentities($text_params['_M2F_ADMIN_EMAIL_ADDRESS_']);
		
	$ml_name = $m2f_handler->get_mailinglist_name($distributionlist_id);
	$ml_address = $m2f_handler->get_mailinglist_address($distributionlist_id);
	$ml_full_address = "&quot;$ml_name&quot; &lt;$ml_address&gt;";
	$forum_name = ($mode == 'default_distribution') ? 'DEFAULT' : $m2f_handler->get_forum_name($distributionlist_id);
	
	$extra_params = array(
	'distributionlist_id' => $distributionlist_id,
	'ml_address' => $ml_full_address,
	'ml_email' => $ml_address,
	'forum_name' => $forum_name,
	'mode' => ($mode == 'default_distribution' ? 'default_distribution' : 'distributionlists'),
	);
	
	
	// Checkboxes and radio buttons
	$check_radio_params = array(
	'_M2F_MAIL_BACKEND_MAIL_' => ($text_params['_M2F_MAIL_BACKEND_'] == 'mail' ? 'CHECKED' : ''),
	'_M2F_MAIL_BACKEND_SENDMAIL_' => ($text_params['_M2F_MAIL_BACKEND_'] == 'sendmail' ? 'CHECKED' : ''),
	'_M2F_SMTP_AUTH_ON_' => ($text_params['_M2F_SMTP_AUTH_'] == '1' ? 'CHECKED' : ''),
	'_M2F_MAIL_BACKEND_SMTP_' => ($text_params['_M2F_MAIL_BACKEND_'] == 'smtp' ? 'CHECKED' : ''),
	'_M2F_INPUT_BACKEND_MBOX_' => ($text_params['_M2F_INPUT_BACKEND_'] == 'mbox' ? 'CHECKED' : ''),
	'_M2F_INPUT_BACKEND_STDIN_' => ($text_params['_M2F_INPUT_BACKEND_'] == 'stdin' ? 'CHECKED' : ''),
	'_M2F_INPUT_BACKEND_POP3_' => ($text_params['_M2F_INPUT_BACKEND_'] == 'pop3' ? 'CHECKED' : ''),
	'_M2F_INPUT_BACKEND_GMAIL_' => ($text_params['_M2F_INPUT_BACKEND_'] == 'gmail' ? 'CHECKED' : ''),
	'_M2F_POP3_APOP_YES_' => ($text_params['_M2F_POP3_APOP_'] == '1' ? 'CHECKED' : ''),
	'_M2F_POP3_APOP_NO_' => ($text_params['_M2F_POP3_APOP_'] == '0' ? 'CHECKED' : ''),
	'_M2F_EXTRACT_MAIL_DATES_ON_' => ($text_params['_M2F_EXTRACT_MAIL_DATES_'] == '1' ? 'CHECKED' : ''),
	'_M2F_IGNORE_TO_HEADER_ON_' => ($text_params['_M2F_IGNORE_TO_HEADER_'] == '1' ? 'CHECKED' : ''),
	'_M2F_NO_REPLYTO_RECP_ON_' => ($text_params['_M2F_NO_REPLYTO_RECP_'] == '1' ? 'CHECKED' : ''),
	'_M2F_EXTERNAL_LIST_SERVER_ON_' => ($text_params['_M2F_EXTERNAL_LIST_SERVER_'] == '1' ? 'CHECKED' : ''),
	'_M2F_EXTERNAL_LIST_SERVER_OFF_' => ($text_params['_M2F_EXTERNAL_LIST_SERVER_'] == '0' ? 'CHECKED' : ''),
	'_M2F_ADD_AUTHOR_AS_RECIPIENT_ON_' => ($text_params['_M2F_ADD_AUTHOR_AS_RECIPIENT_'] == '1' ? 'CHECKED' : ''),
	'_M2F_FROM_USER_' => ($text_params['_M2F_FROM_FIELD_'] == 'user_address' ? 'CHECKED' : ''),
	'_M2F_FROM_LIST_' => ($text_params['_M2F_FROM_FIELD_'] == 'ml_address' ? 'CHECKED' : ''),
	'_M2F_FROM_MIX_' => ($text_params['_M2F_FROM_FIELD_'] == 'user_name_ml_address' ? 'CHECKED' : ''),
	'_M2F_FROM_OTHER_' => ($text_params['_M2F_FROM_FIELD_'] == 'other_address' ? 'CHECKED' : ''),
	'_M2F_FROM_USERNAME_AT_OTHER_ADDRESS_' => ($text_params['_M2F_FROM_FIELD_'] == 'user_name_other_address' ? 'CHECKED' : ''),
	'_M2F_SHOW_GUEST_NAME_ON_' => ($text_params['_M2F_SHOW_GUEST_EMAIL_'] == '2' ? 'CHECKED' : ''),
	'_M2F_SHOW_GUEST_NAME_EMAIL_ON_' => ($text_params['_M2F_SHOW_GUEST_EMAIL_'] == '3' ? 'CHECKED' : ''),
	'_M2F_ALLOW_GUEST_POSTING_ON_' => ($text_params['_M2F_ALLOW_GUEST_POSTING_'] == '1' ? 'CHECKED' : ''),
	'_M2F_ALLOW_GUEST_POSTING_OFF_' => ($text_params['_M2F_ALLOW_GUEST_POSTING_'] == '0' ? 'CHECKED' : ''),
	'_M2F_FORCE_GUEST_POSTING_ON_' => ($text_params['_M2F_FORCE_GUEST_POSTING_'] == '1' ? 'CHECKED' : ''),
	'_M2F_IGNORE_SECURITY_SETTINGS_ON_' => ($text_params['_M2F_IGNORE_SECURITY_SETTINGS_'] == '1' ? 'CHECKED' : ''),
	'_M2F_SHOW_GUEST_EMAIL_ON_' => ($text_params['_M2F_SHOW_GUEST_EMAIL_'] == '1' ? 'CHECKED' : ''),
	'_M2F_SHOW_GUEST_EMAIL_OFF_' => ($text_params['_M2F_SHOW_GUEST_EMAIL_'] == '0' ? 'CHECKED' : ''),
	'_M2F_DISALLOW_GUEST_ACTION_DELETE_' => ($text_params['_M2F_DISALLOW_GUEST_ACTION_'] == 'delete' ? 'CHECKED' : ''),
	'_M2F_DISALLOW_GUEST_ACTION_ADMIN_' => ($text_params['_M2F_DISALLOW_GUEST_ACTION_'] == 'admin' ? 'CHECKED' : ''),
	'_M2F_DISALLOW_GUEST_ACTION_BOUNCE_' => ($text_params['_M2F_DISALLOW_GUEST_ACTION_'] == 'bounce' ? 'CHECKED' : ''),
	'_M2F_DISALLOW_GUEST_ACTION_BOUNCE_AND_ADMIN_' => ($text_params['_M2F_DISALLOW_GUEST_ACTION_'] == 'bounce_and_admin' ? 'CHECKED' : ''),
	'_M2F_DISALLOW_GUEST_ACTION_MODERATE_' => ($text_params['_M2F_DISALLOW_GUEST_ACTION_'] == 'moderate' ? 'CHECKED' : ''),
	'_M2F_BOUNCE_INCLUDE_LINK_ON_' => ($text_params['_M2F_BOUNCE_INCLUDE_LINK_'] == '1' ? 'CHECKED' : ''),
	'_M2F_DELETE_IMPORTED_MESSAGES_ON_' => ($text_params['_M2F_DELETE_IMPORTED_MESSAGES_'] == '1' ? 'CHECKED' : ''),
	'_M2F_RESEND_EDITED_POST_ON_' => ($text_params['_M2F_RESEND_EDITED_POST_'] == '1' ? 'CHECKED' : ''),
	'_M2F_MODERATED_LIST_IN_ON_' => ($text_params['_M2F_MODERATED_LIST_IN_'] == '1' ? 'CHECKED' : ''),
	'_M2F_MODERATED_LIST_OUT_ON_' => ($text_params['_M2F_MODERATED_LIST_OUT_'] == '1' ? 'CHECKED' : ''),
	'_M2F_MODERATOR_NOTIFY_NONE_' => ($text_params['_M2F_MODERATOR_NOTIFY_'] == 'none' ? 'CHECKED' : ''),
	'_M2F_MODERATOR_NOTIFY_ADMIN_' => ($text_params['_M2F_MODERATOR_NOTIFY_'] == 'board_admin' ? 'CHECKED' : ''),
	'_M2F_MODERATOR_NOTIFY_MOD_' => ($text_params['_M2F_MODERATOR_NOTIFY_'] == 'moderators' ? 'CHECKED' : ''),
	'_M2F_MODERATOR_NOTIFY_OTHER_' => ($text_params['_M2F_MODERATOR_NOTIFY_'] == 'other_address' ? 'CHECKED' : ''),
	'_M2F_MODERATOR_IGNORE_ADMIN_ON_' => ($text_params['_M2F_MODERATOR_IGNORE_ADMIN_'] == '1' ? 'CHECKED' : ''),
	);
		
	return $text_params + $extra_params + $check_radio_params;
}

function do_dist_lists_action($action) {
	global $m2f_handler;
	switch($action) {
		case 'Deactivate':
			$m2f_handler->set_distributionlist($_POST['distributionlist_id'] , array("status" => 0));
			break;
				
		case 'Activate':
			$m2f_handler->set_distributionlist($_POST['distributionlist_id'] , array("status" => 1));
			break;

		case 'Hide':
			$m2f_handler->set_distributionlist($_POST['distributionlist_id'] , array("visibility" => 0));
			break;
				
		case 'Show':
			$m2f_handler->set_distributionlist($_POST['distributionlist_id'] , array("visibility" => 1));
			break;
				
		case 'Delete':
			$m2f_handler->delete_distributionlist($_POST['distributionlist_id']);
			break;
				
		case 'Add':
			$m2f_handler->new_distributionlist(array("mailinglist_id" => $_POST['mailinglist_id'], "forum_id" => $_POST['forum_id'], "status" => 0, "visibility" => 1));
			break;
	}
}

function get_forums() {
	global $m2f_handler;
	return $m2f_handler->get_forums();
}

function get_unlinked_mailinglists() {
	global $m2f_handler;
	return $m2f_handler->get_unlinked_mailinglists();
}

function get_dist_lists() {
	global $m2f_handler;
	
	$distributionlists = $m2f_handler->get_distributionlists();
	$params = array();
	
	if (count($distributionlists) != 0) {
		foreach ($distributionlists as $distributionlist_id => $distributionlist_details)
		{
			$params[] = array(
			 'distributionlist_id' => $distributionlist_id,
			 'mailinglist_id' => $distributionlist_details['mailinglist_id'],
			 'list_email' => $distributionlist_details['list_email'],
			 'mailinglist_name' => $distributionlist_details['mailinglist_name'], 
			 'forum_id' => $distributionlist_details['forum_id'],
			 'forum_name' => $distributionlist_details['forum_name'],
			 'status' => ($distributionlist_details['status'] == 1) ? '<span style="color:#006600">active</span>' : '<span style="color:#BB0000">inactive</span>',
			 'visibility' => ($distributionlist_details['visibility'] == 1) ? '<span style="color:#006600">visible</span>' : '<span style="color:#BB0000">hidden</span>',
			 'status_action' => ( $distributionlist_details['status']==0 ? 'Activate' : 'Deactivate'),
			 'visibility_action' => ( $distributionlist_details['visibility']==0 ? 'Show' : 'Hide'),
		 );
		}
	}
	return $params;
}


function move_pattern_up($dist_id, $pattern_id) {
	global $m2f_db;

	$sql = 'SELECT pattern_order FROM ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_id = ' . $pattern_id;
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	$orig_order = $db_result;

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  0 WHERE distributionlist_id = ' . $dist_id . ' AND pattern_order = ' . ($orig_order - 1);
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  ' . ($orig_order - 1) . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_id = ' . $pattern_id;
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  ' . $orig_order . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_order = 0';
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}

function move_pattern_down($dist_id, $pattern_id) {
	global $m2f_db;

	$sql = 'SELECT pattern_order FROM ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_id = ' . $pattern_id;
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	$orig_order = $db_result;

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  0 WHERE distributionlist_id = ' . $dist_id . ' AND pattern_order = ' . ($orig_order + 1);
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  ' . ($orig_order + 1) . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_id = ' . $pattern_id;
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$sql = 'UPDATE ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' SET pattern_order =  ' . $orig_order . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_order = 0';
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}

function remove_pattern_link($dist_id, $pattern_id) {
	global $m2f_db;
	
	$sql = 'DELETE FROM  ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' WHERE distributionlist_id = ' . $dist_id . ' AND pattern_id = ' . $pattern_id;
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}

function add_pattern($mode) {
	global $m2f_db;
	
	$target = is_array($_POST['target']) ? array_sum($_POST['target']) : 0;
	
	$sql = 'INSERT INTO  ' . _M2F_PATTERN_MATCH_TABLE_ . " (pattern_match, pattern_replace, use_regexp, description, modifiers, target, purpose) VALUES ('" . 
		$m2f_db->escapeSimple($_POST['match']) . "', '" . 
		$m2f_db->escapeSimple($_POST['replace']) . "', '" . 
		(($_POST['use_regexp'] == '1') ? '1' : '0') . "', '" . 
		$m2f_db->escapeSimple($_POST['description']) . "', '" . 
		$m2f_db->escapeSimple($_POST['modifiers']) . "', '" . 
		$target . "', '" . 
		($mode == 'pattern_matching' ? 'search' : 'block'). '\')';
		
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}


function test_pattern_sample_preg()
{
	$sample = str_replace("\r\n", "\n", $_POST['sample']);
	$match = str_replace("\r\n", "\n", $_POST['match']);
	$replace = str_replace("\r\n", "\n", $_POST['replace']);
	$modifiers = $_POST['modifiers'];
	$replace_html = '<span style="color:blue; text-decoration: line-through;">$0</span><span style="color:red">' . $replace . '</span>';
	$search = '/' . $match . '/' . $modifiers;
	$html = '<h1>Result (displayed as HTML):</h1><br /><pre>' . preg_replace($search, $replace_html, $sample) . '</pre><br /><br />';
	$text = '<h1>Result (raw text):</h1><br /><pre>' . htmlentities(preg_replace($search, $replace, $sample)) . '</pre><br /><br />';


	return $html . $text;
}

function test_pattern_sample()
{
	$sample = $_POST['sample'];
	$match = $_POST['match'];
	$replace = $_POST['replace'];

	// a complex function to imitate the behaviour of str_replace. I used this rather than preg_replace, as str_replace will be used in the live environment. Georgec.
	$temp = ""; 
	$i = 0; 
	while($i < strlen($sample))
	{ 
		 if ((($i + strlen($match)) <= strlen($sample)) && (strcmp($match, substr($sample, $i, strlen($match))) == 0)) 
		 { 
				$temp .= '<span style="color:blue; text-decoration: line-through;">' . substr($sample, $i , strlen($match)) . '</span><span style="color:red">' . $replace . '</span>'; 
				$i += strlen($match); 
		 } 
		 else 
		 { 
				$temp .= $sample{$i}; 
				$i++; 
		 } 
	} 
		 
	$html = '<h1>Result (displayed as HTML):</h1><br /><pre>' . $temp . '</pre><br /><br />';
	$text = '<h1>Result (raw text):</h1><br /><pre>' . htmlentities(str_replace($match, $replace, $sample)) . '</pre><br /><br />';

	return $html . $text;
}

function test_pattern_modifiers($modifiers)
{
	$bad = array();
	$allowed = array('i', 'm', 's', 'x', 'e', 'A', 'D', 'S', 'U', 'X', 'u');
	$modifiers = preg_split('//', $modifiers, -1, PREG_SPLIT_NO_EMPTY);
	$eval_modifier = FALSE;
	
	foreach ($modifiers as $mod)
	{
		if (!in_array($mod, $allowed))
		{
			$bad[] = $mod;
		}
		if ($mod == 'e')
		{
			$eval_modifier = TRUE;
		}
	}
	return array($bad, $eval_modifier);
}

function test_pattern_match_string($str)
{
	set_error_handler("trapError");
	preg_match ('/' . $str . '/', "");
	restore_error_handler();
	return trapError ();
}

function trapError ()
{
    static $iERRORES, $error_strings;
    if (!func_num_args ())
    {
        $iRETORNO = $iERRORES;
        $iERRORES = 0;
        return array($iRETORNO, $error_strings);
    }
    else
    {
        $iERRORES++;
        $error_strings[] = func_get_arg(1);
    }
}

function update_pattern() {
	global $m2f_db;
	
	$target = is_array($_POST['target']) ? array_sum($_POST['target']) : 0;

	$sql = 'UPDATE  ' . _M2F_PATTERN_MATCH_TABLE_ . ' SET ' . 
		'pattern_match = \'' .  $m2f_db->escapeSimple($_POST['match']) . '\', ' . 
		'pattern_replace = \'' .  $m2f_db->escapeSimple($_POST['replace']) . '\', ' . 
		'use_regexp = \'' .  (($_POST['use_regexp'] == '1') ? '1' : '0') . '\', ' . 
		'description = \'' .  $m2f_db->escapeSimple($_POST['description']) . '\', ' . 
		'modifiers = \'' .  $m2f_db->escapeSimple($_POST['modifiers']) . '\', ' . 
		'target = \'' .  $target . '\' 
			WHERE pattern_id = ' . $_POST['id'];
		
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}

function delete_pattern() {
	global $m2f_db;
	
	$sql = 'DELETE FROM  ' . _M2F_PATTERN_MATCH_TABLE_ . ' WHERE pattern_id = ' . $_POST['id'];
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	
	$sql = 'DELETE FROM  ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' WHERE pattern_id = ' . $_POST['id'];
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}

function get_patterns($id = FALSE, $mode = FALSE) {
	global $m2f_db;
	
	$sql = 'SELECT * FROM  ' . _M2F_PATTERN_MATCH_TABLE_;
	$sql .= ($id) ? ' WHERE pattern_id = ' . $id : '';
	if ($mode) $sql .= ($mode == 'pattern_matching') ? " WHERE purpose = 'search'" : (($mode == 'pattern_matching_block') ? " WHERE purpose = 'block'" : '');
	$sql .= ' ORDER BY internal, pattern_id DESC';
	
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	
	return $db_result;
}

function get_linked_patterns($dist_id, $mode)
{
	global $m2f_db;
	
	// patterns 1 and 2 are always run
	$sql = "SELECT * FROM  " . _M2F_PATTERN_MATCH_TABLE_ . " p, " . _M2F_DIST_LIST_PATTERNS_TABLE_ . " dp
					WHERE dp.distributionlist_id = '$dist_id'
						AND p.pattern_id = dp.pattern_id 
						AND p.purpose = '$mode'
					ORDER BY dp.pattern_order";
		
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	
	return $db_result;
}

function get_unlinked_patterns($dist_id, $mode)
{
	global $m2f_db;
	
	$sql = 'SELECT pattern_id FROM ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . '
					WHERE distributionlist_id = ' . $dist_id;
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	
	$links[] = 0;
	foreach ($db_result as $value) $links[] = $value['pattern_id'];
	$links = implode(', ', $links);
	
	$sql = "SELECT * FROM  " . _M2F_PATTERN_MATCH_TABLE_ . "
					WHERE pattern_id NOT IN ($links) 
						AND purpose = '$mode'
					ORDER BY pattern_id";
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}

function link_pattern($pattern_id, $dist_id)
{
	global $m2f_db;
	
	$sql = 'SELECT pattern_order from ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' 
						WHERE distributionlist_id = ' . $dist_id . '
						ORDER BY pattern_order DESC LIMIT 1';
						
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$next_order = $db_result ? $db_result + 1: 1;

	$sql = 'INSERT INTO ' . _M2F_DIST_LIST_PATTERNS_TABLE_ . ' 
		 			(distributionlist_id, pattern_id, pattern_order)
		 			VALUES (\'' . $dist_id . '\', \'' . $pattern_id . '\', \'' . $next_order . '\')';
		
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
}


function force_import() {
	global $m2f_handler;

	$results_array = $m2f_handler->import_msgs();
	$time_taken = $results_array['time'];
	unset($results_array['time']);
	
	if (!empty($results_array))
	{
		$results_table = '<table align="center" border="1" cellpadding="7" cellspacing="0">
			<tr><th colspan="5"><b>Import Results</b></td></tr>
			<tr>
				<td valign="top" align="center"><b>Forum<br />(mailing list)</b></td>
				<td valign="top" align="center"><b>Imported<br />messages</b></td>
				<td valign="top" align="center"><b>Ignored<br />messages*</b></td>
				<td valign="top" align="center"><b>Posted<br />messages</b></td>
				<td valign="top" align="center"><b>Moderated<br />messages</b></td>
			</tr>';
		
		$any_max_reached = false;
		
		foreach ($results_array as $distributionlist_id => $results)
		{
			$max_reached = false;
			$forum_name = $m2f_handler->get_forum_name($distributionlist_id);
			$mailinglist_name = $m2f_handler->get_mailinglist_name($distributionlist_id);
			$good = $results['IMPORTED'];
			$ignored = $results['IGNORED'];
			$posted = $results['POSTED'];
			$moderated = $results['MODERATED'];
			$max_msgs = $results['MAX_IMPORT'];
			if ( ($max_msgs != 0) && ($good + $ignored == $max_msgs) )
			{
				$max_reached = true;
				$any_max_reached = true;
			}
			$results_table .= '<tr><td>';
			$results_table .= ($max_reached == true) ? '<span style="color:#FF0000">' : '';
			$results_table .= "$forum_name ($mailinglist_name)";
			$results_table .= ($max_reached == true) ? '</span>' : '';
			$results_table .= "</td><td align=\"center\">$good</td>\n<td align=\"center\">$ignored</td>\n<td align=\"center\">$posted</td>\n<td align=\"center\">$moderated</td></tr>\n";
		}
		
		$results_table .= '</table><br /><span class="gensmall"><b>*</b>Ignored messages are those generated by m2f, or rejected <br />for some reason by the distribution list settings.</span>';
		
		$message = '<br /><br />The import script ran succesfully in ' . $time_taken . ' seconds:';
		$message .= '<br /><br /><br /><br />';
		$message .= $results_table;
		$message .= '<br /><br />';
		$message .= ($any_max_reached == true) ? '<span style="color:#FF0000">Any highlighted distribution lists reached the maximum number of imported messages.<br />You may like to force import again to see if there are any more.</span><br /><br />' : '';
	}
	else
	{
		$message = 'There were no distribution lists to import from<br /><br />';
	}
	
	return $message;
}

function get_log_file()
{
	if (isset($_GET['view_complete_log']))
	{
		if (function_exists('file_get_contents'))
		{
			$log_file = file_get_contents(_M2F_LOG_FILE_);
		}
		else
		{
			$handle = @fopen(_M2F_LOG_FILE_, 'r');
			$log_file = @fread($handle, filesize(_M2F_LOG_FILE_));
			fclose($handle);					
		}
		$truncated = '';
	}
	else
	{
		$handle = @fopen(_M2F_LOG_FILE_, 'r');
		if (!$handle)
		{
			m2f_display_error("[" . __FILE__ . " : " . __LINE__ . "] Could not read log file");
			die;
		}
		$size = filesize(_M2F_LOG_FILE_);
		$truncate_limit = 10000;
		fseek($handle, -$truncate_limit, SEEK_END);
		$log_file = @fread($handle, $size);
		fclose($handle);

		$log_file = strstr($log_file, "\n\n");
		$truncated = $size > $truncate_limit ? "<b>(truncated)</b>\n" : '';
	}
	
	$log_file = htmlspecialchars($log_file);			
	return $truncated . $log_file;
}			
			
function erase_db_log()
{
	global $m2f_db;
	$sql = 'TRUNCATE TABLE ' . _M2F_LOG_TABLE_;
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return;
}

function erase_file_log()
{
	$handle = @fopen(_M2F_LOG_FILE_, 'w');
	ftruncate($handle, 0);
	return;
}


function get_db_log()
{
	global $m2f_db;
	
	switch($m2f_db->dbsyntax)
	{
		case 'mysql':
			$sql = 'SELECT DATE_FORMAT(logtime, \'%e&nbsp;%b&nbsp;%y,&nbsp;%H:%i:%s\') AS logtime, priority, message FROM ' . _M2F_LOG_TABLE_;
			if (isset($_GET['dayfrom'])) $sql .= " WHERE logtime BETWEEN '$_GET[yearfrom]$_GET[monthfrom]$_GET[dayfrom]$_GET[hourfrom]$_GET[minutefrom]00' AND '$_GET[yearto]$_GET[monthto]$_GET[dayto]$_GET[hourto]$_GET[minuteto]59' ORDER BY id DESC";
			else if (isset($_GET['view_complete_log'])) $sql .= ' ORDER BY id DESC'; 
			else $sql .= ' ORDER BY id DESC LIMIT 30'; 
			break;

		case 'pgsql':
			$sql = "SELECT TO_CHAR (logtime,'FMDD&nbsp;Mon&nbsp;YY,&nbsp;HH24:MI:SS') AS logtime, priority, message FROM " . _M2F_LOG_TABLE_;
			if (isset($_GET['dayfrom'])) $sql .= " WHERE logtime BETWEEN '$_GET[yearfrom]-$_GET[monthfrom]-$_GET[dayfrom] $_GET[hourfrom]:$_GET[minutefrom]:00' AND '$_GET[yearto]-$_GET[monthto]-$_GET[dayto] $_GET[hourto]:$_GET[minuteto]:59' ORDER BY id DESC";
			else if (isset($_GET['view_complete_log'])) $sql .= ' ORDER BY id DESC'; 
			else $sql .= ' ORDER BY id DESC LIMIT 30'; 
			break;
	}

	$db_result =& $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}
		
		
function add_to_url()
{
	$url = '';
	if (isset($_POST['view_log_period'])) $url .= "&dayfrom=$_POST[dayfrom]&monthfrom=$_POST[monthfrom]&yearfrom=$_POST[yearfrom]&hourfrom=$_POST[hourfrom]&minutefrom=$_POST[minutefrom]&dayto=$_POST[dayto]&monthto=$_POST[monthto]&yearto=$_POST[yearto]&hourto=$_POST[hourto]&minuteto=$_POST[minuteto]";
	if (isset($_POST['view_complete_log'])) $url .= '&view_complete_log=1';
	return $url;
}

function date_from()
{
	return date_select($_POST['dayfrom'], $_POST['monthfrom'], $_POST['yearfrom'], $_POST['hourfrom'], $_POST['minutefrom'], 'from');
}

function date_to()
{
	return date_select($_POST['dayto'], $_POST['monthto'], $_POST['yearto'], $_POST['hourto'], $_POST['minuteto'], 'to');
}

function last_hour()
{
	$last_hour = time() - 3600;
	return date_select(date('d', $last_hour), date('m', $last_hour), date('Y', $last_hour), date('H', $last_hour), date('i', $last_hour), 'from');
}

function this_hour()
{
	return date_select(date('d'), date('m'), date('Y'), date('H'), date('i'),'to');
}

function save_m2f_settings ()
{
	global $m2f_config, $m2f_handler, $m2f_db;

	// update user preferences
	$_POST['_M2F_DEFAULT_EMAIL_PREFS_'] = $_POST['_M2F_USER_HTML_EMAIL_PREF_'] +
																				$_POST['_M2F_ATTACHMENTS_PREF_'] +
																				$_POST['_M2F_IMAGES_INLINE_PREF_'] +
																				$_POST['_M2F_THUMBNAIL_IMAGES_PREF_'];

	$config_list = array(		
		'_M2F_SENDMAIL_PATH_',
		'_M2F_SENDMAIL_ARGS_',
		'_M2F_FORUM_POST_SIGNATURE_',
		'_M2F_MAIL_MSG_SIGNATURE_',
		'_M2F_ANON_USERID_',
		'_M2F_BLANK_SUBJECT_TEXT_',
		'_M2F_SUBJECT_REPLY_PREFIX_',
		'_M2F_FORCE_SUBJECT_MATCH_',
		'_M2F_SEND_HTML_',
		'_M2F_ENABLE_ATTACHMENTS_',
		'_M2F_SEND_ATTACHMENT_LINK_',
		'_M2F_CRON_PROBABILITY_',
		'_M2F_CRON_DELAY_',
		'_M2F_INCLUDE_SIGNATURE_LINK_',
		'_M2F_LOG_PRUNE_',
		'_M2F_HASH_PRUNE_',
		'_M2F_DEFAULT_EMAIL_PREFS_',
		);

	foreach($config_list as $name)
	{
		// Update the config information
		$sql = "UPDATE " . _M2F_CONFIG_TABLE_ . "
					SET config_value = '" . $m2f_db->escapeSimple($_POST[$name]) . "'
					WHERE config_name = '$name'";

		$db_result = $m2f_db->query($sql);
		check_db_result($db_result, $sql, __LINE__, __FILE__);
	}


/*		
	// Add a pattern to the Pattern Matching DB to strip the _M2F_FORUM_POST_SIGNATURE_ from incoming emails
	// NB. this is always Pattern ID '1'
	$orig = $_POST['_M2F_FORUM_POST_SIGNATURE_'];
	$sql = 'UPDATE  ' . _M2F_PATTERN_MATCH_TABLE_ . ' SET ' . 
		'pattern_match = \'' .  $m2f_db->escapeSimple(preg_quote($_POST['_M2F_FORUM_POST_SIGNATURE_'], '/')) . '\' ' . 
		'WHERE pattern_id = \'1\'';
		
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	
	// Add a pattern to the Pattern Matching DB to strip the _M2F_MAIL_MSG_SIGNATURE_ from incoming emails
	// NB. this is always Pattern ID '2'
	$orig = $_POST['_M2F_MAIL_MSG_SIGNATURE_'];
//		$match_string = str_replace('\<\<topic_link\>\>', 'http.*?\?p\=\d+#\d+', preg_quote($_POST['_M2F_MAIL_MSG_SIGNATURE_'], '/'));
//		$match_string = preg_quote(substr($orig, 0, 10), '/') . '.*' . 'http.*\?p\=\d+#\d+.*' . preg_quote(substr($orig, -10, 10), '/');
	
	if ($link_pos = strpos($orig, '<topic_link>'))
	$start = substr($orig, 0, strpos($orig, '<topic_link>'));
	
echo substr($string, 0, strpos($string, 'xxxx'));

	
	$sql = 'UPDATE  ' . _M2F_PATTERN_MATCH_TABLE_ . ' SET ' . 
		'pattern_match = \'' .  $m2f_db->escapeSimple($match_string) . '\' ' . 
		'WHERE pattern_id = \'2\'';
		
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
*/

}

function get_m2f_settings()
{
	global $m2f_db, $m2f_config;
	
	$m2f_version = $m2f_config['_M2F_VERSION_'];
	
  $sql = "SELECT config_name, config_value FROM " . _M2F_CONFIG_TABLE_;
  $db_result =& $m2f_db->getAssoc($sql, false, array(), DB_FETCHMODE_DEFAULT, true);

  foreach ($db_result as $key => $value)
  {
  	if (count($value) > 1)
  	{
  		$m2f_config[$key] = $value;
  	}
  	else
  	{
  		$m2f_config[$key] = $value[0];
  	}
  }
  
	$m2f_config['_M2F_VERSION_'] = $m2f_version;
	
	return $m2f_config + array(
	    '_M2F_ENABLE_ATTACHMENTS_YES_' => $m2f_config['_M2F_ENABLE_ATTACHMENTS_'] == '1' ? 'SELECTED' : '',
			'_M2F_ENABLE_ATTACHMENTS_NO_' => $m2f_config['_M2F_ENABLE_ATTACHMENTS_'] == '0' ? 'SELECTED' : '',
	    '_M2F_SEND_ATTACHMENT_LINK_YES_' => $m2f_config['_M2F_SEND_ATTACHMENT_LINK_'] == '1' ? 'SELECTED' : '',
			'_M2F_SEND_ATTACHMENT_LINK_NO_' => $m2f_config['_M2F_SEND_ATTACHMENT_LINK_'] == '0' ? 'SELECTED' : '',
			'_M2F_FORCE_SUBJECT_MATCH_YES_' => $m2f_config['_M2F_FORCE_SUBJECT_MATCH_'] == '1' ? 'SELECTED' : '',
			'_M2F_FORCE_SUBJECT_MATCH_NO_' => $m2f_config['_M2F_FORCE_SUBJECT_MATCH_'] == '0' ? 'SELECTED' : '',
			'_M2F_SEND_HTML_YES_' => $m2f_config['_M2F_SEND_HTML_'] == '1' ? 'SELECTED' : '',
			'_M2F_SEND_HTML_NO_' => $m2f_config['_M2F_SEND_HTML_'] == '0' ? 'SELECTED' : '',
			'_M2F_INCLUDE_SIGNATURE_LINK_YES_' => $m2f_config['_M2F_INCLUDE_SIGNATURE_LINK_'] == '1' ? 'SELECTED' : '',
			'_M2F_INCLUDE_SIGNATURE_LINK_NO_' => $m2f_config['_M2F_INCLUDE_SIGNATURE_LINK_'] == '0' ? 'SELECTED' : '',
			'_M2F_USER_HTML_EMAIL_YES_' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_HTML_EMAIL_) ? 'SELECTED' : '',
			'_M2F_USER_HTML_EMAIL_NO_' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_HTML_EMAIL_) ? '' : 'SELECTED',
			'_M2F_ATTACHMENTS_IGNORE_' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_IGNORE_ATTACHMENTS_) ? 'SELECTED' : '', 
			'_M2F_ATTACHMENTS_LINKS_' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_ATTACHMENT_LINKS_) ? 'SELECTED' : '',
			'_M2F_ATTACHMENTS_ATTACH_' => (($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_IGNORE_ATTACHMENTS_)  or ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_ATTACHMENT_LINKS_)) ? '' : 'SELECTED',
			'_M2F_USER_IMAGES_INLINE_YES' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_IMAGES_INLINE_) ? 'SELECTED' : '',
			'_M2F_USER_IMAGES_INLINE_NO' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_IMAGES_INLINE_) ? '' : 'SELECTED',
			'_M2F_USER_THUMBNAIL_IMAGES_YES' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_THUMBNAIL_IMAGES_) ? 'SELECTED' : '',
			'_M2F_USER_THUMBNAIL_IMAGES_NO' => ($m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] & _M2F_USER_THUMBNAIL_IMAGES_) ? '' : 'SELECTED',
			'_M2F_USER_HTML_EMAIL_' => _M2F_USER_HTML_EMAIL_,
			'_M2F_USER_IGNORE_ATTACHMENTS_' => _M2F_USER_IGNORE_ATTACHMENTS_,
			'_M2F_USER_ATTACHMENT_LINKS_' => _M2F_USER_ATTACHMENT_LINKS_,
			'_M2F_USER_IMAGES_INLINE_' => _M2F_USER_IMAGES_INLINE_,
			'_M2F_USER_THUMBNAIL_IMAGES_' => _M2F_USER_THUMBNAIL_IMAGES_,
			'_M2F_MAX_USER_PREF_' => _M2F_MAX_USER_PREF_,
			);
}

function get_moderated_messages($id=NULL, $num=NULL, $dir=NULL)
{
	global $m2f_db;
	
	$sql = 'SELECT * FROM ' . _M2F_MODERATED_MSGS_TABLE_;
	if (!is_null($id) && is_null($num)) $sql .= " WHERE id = '$id'";
	if (!is_null($dir)) $sql .= " WHERE direction = '$dir'";
	$sql .= ' ORDER BY time ASC';
	if (!is_null($id) && !is_null($num)) $sql .= " LIMIT $num OFFSET $id";
	$db_result = $m2f_db->getAll($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}

function count_moderated_messages()
{
	global $m2f_db;

	$sql = 'SELECT direction, count(*) FROM ' . _M2F_MODERATED_MSGS_TABLE_ . ' GROUP BY direction';
	$db_result = $m2f_db->getAssoc($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	$in = isset($db_result['in']) ? (int) $db_result['in'] : 0;
	$out = isset($db_result['out']) ? (int) $db_result['out'] : 0;

	return array($in, $out);
}

function delete_moderated_message($message_id, $post_id = NULL)
{
	global $m2f_db;

	$sql = 'DELETE FROM ' . _M2F_MODERATED_MSGS_TABLE_ . " WHERE id = '$message_id'";
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);

	if ($post_id)
	{
		$sql = 'DELETE FROM ' . POSTS_TABLE . " WHERE post_id = '$post_id'";
		$db_result = $m2f_db->query($sql);
		check_db_result($db_result, $sql, __LINE__, __FILE__);
	}
	
	return;
}
	
function get_topic_details($topic_id)
{
	global $m2f_db;

	$sql = 'SELECT topic_title FROM ' . TOPICS_TABLE . " 
					WHERE topic_id = '$topic_id'";
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}

function get_post_details($post_id)
{
	global $m2f_db;

	$sql = "SELECT pt.post_subject as post, t.topic_title as topic
						FROM " . POSTS_TEXT_TABLE . " pt,
						" . POSTS_TABLE . " p,
						" . TOPICS_TABLE . " t
					WHERE p.post_id = '$post_id'
						AND p.post_id = pt.post_id
						AND t.topic_id = p.topic_id
					";
	$db_result = $m2f_db->getRow($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return ($db_result['post']) ? $db_result['post'] : $db_result['topic'];
}

function get_forum_name($forum_id)
{
	global $m2f_db;

	$sql = 'SELECT forum_name FROM ' . FORUMS_TABLE . " 
					WHERE forum_id = '$forum_id'";
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}

function get_topic_id($message_id)
{
	global $m2f_db;

	$sql = 'SELECT topic_id FROM ' . _M2F_MODERATED_MSGS_TABLE_ . " 
					WHERE id = '$message_id'";
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return $db_result;
}

function change_topic_id($message_id, $topic_id)
{
	global $m2f_db;

	$sql = 'UPDATE ' . _M2F_MODERATED_MSGS_TABLE_ . " 
					SET topic_id = '$topic_id'
					WHERE id = '$message_id'";
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return;
}

function check_topic_id($topic_id)
{
	global $m2f_db;

	$sql = 'SELECT count(topic_id) FROM ' . TOPICS_TABLE . " 
					WHERE topic_id = '$topic_id'";
	$db_result = $m2f_db->getOne($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	return ($topic_id == 0) ? TRUE : $db_result;
}

function display_moderated_message($message, $direction, $checkbox=TRUE)
{
	global $m2f_handler, $lang, $phpbb_root_path, $template, $start, $phpEx, $images, $attach_config;
	$message['forum_msg'] = unserialize(base64_decode($message['forum_msg']));
	$message['userdata'] = unserialize(base64_decode($message['userdata']));
	$message['mail_msg'] = unserialize(base64_decode($message['mail_msg']));

	if (isset($message['forum_msg']->post_id))
	{
		$topic_title = get_post_details($message['forum_msg']->post_id);
		$topic_title = (strlen($topic_title) > 20) ? substr($topic_title, 0, 20) . '...' : $topic_title;
		$topic_link = '<a href="' . append_sid("../viewtopic.$phpEx?p=" . $message['forum_msg']->post_id) . "#" . $message['forum_msg']->post_id . "\" target=\"_blank\">$topic_title</a>";
	}
	else if (empty($message['topic_id']))
	{
		$topic_link = '<em>(new topic)</em>';
	}
	else
	{
		$topic_title = get_topic_details($message['topic_id']);
		$topic_title = (strlen($topic_title) > 20) ? substr($topic_title, 0, 20) . '...' : $topic_title;
		$topic_link = '<a href="' . append_sid("../viewtopic.$phpEx?t=$message[topic_id]") . "\" target=\"_blank\">$topic_title</a>";
	}
	
	$mailinglist_name = $m2f_handler->get_mailinglist_name($message['distributionlist_id']);
	$mailinglist_address = $m2f_handler->get_mailinglist_address($message['distributionlist_id']);
	
	$forum_name = get_forum_name($message['forum_id']);
	$forum_link = '<a href="' . append_sid("../viewforum.$phpEx?f=" . $message['forum_id']) . "\" target=\"_blank\">$forum_name</a>";
	
	if (!empty($message['forum_msg']->title))
	{
		$subject = (strlen($message['forum_msg']->title) > 20) ? substr($message['forum_msg']->title, 0, 20) . '...' : $message['forum_msg']->title;
	}
	else
	{
		$subject = $topic_title;
	}
	
	$username = empty($message['userdata']['username']) ? $lang['Guest'] : '<a href="' . append_sid('../profile.php?mode=viewprofile&u=' . $message['userdata']['user_id']) . '" target="_blank">' . $message['userdata']['username'] . '</a>';

	if (!isset($message['forum_msg']->datetime)) $message['forum_msg']->datetime = $message['time'];
	$date = ($message['forum_msg']->datetime == time()) ? 'Today, ' . date('g.i a', $message['forum_msg']->datetime) : date('d M Y, g.i a', $message['forum_msg']->datetime);
	
	$attachments = '';

	if (count($message['mail_msg']->attachments->attach_data))
	{
		foreach ($message['mail_msg']->attachments->attach_data as $attachment)
		{
			$size_lang = ($attachment->size >= 1048576) ? $lang['MB'] : ( ($attachment->size >= 1024) ? $lang['KB'] : $lang['Bytes'] );
			if ($attachment->size >= 1048576)
			{
				$attachment->size = (round((round($attachment->size / 1048576 * 100) / 100), 2));
			}
			else if ($attachment->size >= 1024)
			{
				$attachment->size = (round((round($attachment->size / 1024 * 100) / 100), 2));
			}
			$size = ($attachment->size) ? '(' . $attachment->size . '&nbsp;' . $size_lang . ')' : '';
			$attachments .= '<a href="' . $phpbb_root_path . $attach_config['upload_dir'] . '/' . $attachment->physical_name . '" target="_blank">' . $attachment->filename . '</a>&nbsp;' . $size . '<br />';
		}
	} 
	else 
	{
		$attachments = '<em>(none)</em>';
	}
	
	$template->assign_block_vars('switch_messages_' . $direction . '.messages', array(
		'checkbox' => $checkbox ? '<input type="checkbox" name="message_ids[]" value="' . $message['id'] . '" />' : '',
		'forum_link' => $forum_link,
		'mailinglist_name' => $mailinglist_name,
		'mailinglist_email' => $mailinglist_address,
		'topic_link' => $topic_link,
		'subject' => $subject,
		'from_email' => isset($message['mail_msg']->headers['from']) ? htmlentities($message['mail_msg']->headers['from']) : '',
		'username' => $username,
		'date' => $date,
		'attachments' => $attachments,
		'color_class' => $message['reason'],
		'preview_link' => '<a href="' . append_sid("admin_m2f.$phpEx?mode=moderate&message_id=" . $message['id'] . "&direction=$direction&start=$start&action=preview") . '"><img src="../templates/subSilver/images/icon_mini_search.gif" alt="Preview message" title="Preview message" width="13" height="14" border="0"></a>'
	));
}
?>