<?php
/**
  * Retrieve msgs from mbox, pop, or stdin.
  * Should be run from a crontab in pop3 and mbox mode.
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Revision: 1.16 $
  * @internal $Id: m2f_import_msgs.php,v 1.16 2006/04/18 00:18:18 georgeocrawford Exp $
*/

ignore_user_abort(true);

if (isset($_SERVER['SCRIPT_FILENAME']))
{
	chdir(dirname(realpath($_SERVER['SCRIPT_FILENAME'])));
}
define('IN_PHPBB', true);

// modify this to point to your phpbb directory, relevant to this file. e.g. './phpBB2/'
$phpbb_root_path = '../';
$m2f_root_path = '../m2f/';

// pnphpbb specifics by ksg-serg
if(isset($ModName)) 
{
  $phpbb_root_path = './modules/' . $ModName . '/';
  $m2f_root_path = $phpbb_root_path.'m2f/';
}

// Do not change anything from this point -----------------------------------------------
// --------------------------------------------------------------------------------------
include_once($phpbb_root_path . 'extension.inc');
include_once($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include_once($phpbb_root_path . 'includes/functions_search.'.$phpEx);

include_once($m2f_root_path  . 'm2f_phpbb204.php');

// M2F-Cron: We check if we need to run it
// First see if we have a cron check request
if ($_REQUEST['m2f_cron_check']=="1")
{
  If ((rand()/ getrandmax() ) < _M2F_CRON_PROBABILITY_)
  {    
  	// Run M2F-Cron
  	if (!isset($m2f_handler))
  	  $m2f_handler = new m2f_handler();
  	  
  	$m2f_handler->m2f_cron->run();
  }
}
else
{
  $results_array = $m2f_handler->import_msgs();
}

?>