<?php
/**
  * M2F Admin.
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Revision: 1.18 $
  * @internal $Id: m2f_usercp.php,v 1.18 2006/03/07 22:29:25 georgeocrawford Exp $
*/

define('IN_PHPBB', true);


// Include phpBB functions
$phpbb_root_path = './';

// pnphpbb specifics by ksg-serg
if(isset($ModName)) 
{
  $phpbb_root_path = './modules/' . $ModName . '/';
  $m2f_root_path = $phpbb_root_path.'m2f/';
}

include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_VIEWMEMBERS);
init_userprefs($userdata);

// is the user logged in, in not then give them an authentication message
if ( !$userdata['session_logged_in'] )
{
  redirect(append_sid("login.$phpEx?redirect=m2f_usercp.$phpEx", true));
}


//
// End session management
//


$template->set_filenames(array(
      		'body' => 'm2f_usercp.tpl')
      );
      
//$gen_simple_header = TRUE;
$page_title = 'Subscriptions';
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

// Include M2F functions
$m2f_root_path = $phpbb_root_path . 'm2f/';
require_once($m2f_root_path. 'm2f_phpbb204.php');

// Get current mode
if( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
{
	$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
}
else
{
	$mode = '';
}


if ($mode == 'Save Settings')
{
	// update user preferences
	$user_pref = $HTTP_POST_VARS['_M2F_USER_HTML_EMAIL_PREF_'] +
							 $HTTP_POST_VARS['_M2F_ATTACHMENTS_PREF_'] +
							 $HTTP_POST_VARS['_M2F_IMAGES_INLINE_PREF_'] +
							 $HTTP_POST_VARS['_M2F_THUMBNAIL_IMAGES_PREF_'] ;
	$sql = "UPDATE " . USERS_TABLE . " set m2f_user_prefs = " . $user_pref . "  WHERE user_id = " . $userdata['user_id'];
	if (!($result = $db->sql_query($sql)))
	{
  	message_die(GENERAL_ERROR, 'Could not update user preferences', '', __LINE__, __FILE__, $sql);
	}
	else
	{
		$message = 'Your preferences have been saved.' . "<br /><br />" . sprintf('Click %shere%s to return to Forum subscriptions' , "<a href=\"" . append_sid("m2f_usercp.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_index'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");
		message_die(GENERAL_MESSAGE, $message);
	}
}	

// Get the email of the current user
$sql = "SELECT u.user_id, u.user_email, u.user_lang, u.m2f_user_prefs
  FROM " . USERS_TABLE . " u
  WHERE u.user_id = " . $userdata['user_id'];

if (!($result = $db->sql_query($sql)))
{
  message_die(GENERAL_ERROR, 'Could not obtain user email', '', __LINE__, __FILE__, $sql);
}

$row = $db->sql_fetchrow($result);
$user_email = $row['user_email'];
$user_prefs = ($row['m2f_user_prefs'] == -1) ? $m2f_config['_M2F_DEFAULT_EMAIL_PREFS_'] : $row['m2f_user_prefs'];

$template->assign_vars(array('user_email' => $user_email ));

$template->assign_vars(array(
			'_M2F_USER_HTML_EMAIL_YES_' => ($user_prefs & _M2F_USER_HTML_EMAIL_) ? 'SELECTED' : '',
			'_M2F_USER_HTML_EMAIL_NO_' => ($user_prefs & _M2F_USER_HTML_EMAIL_) ? '' : 'SELECTED',
			'_M2F_ATTACHMENTS_IGNORE_' => ($user_prefs & _M2F_USER_IGNORE_ATTACHMENTS_) ? 'SELECTED' : '', 
			'_M2F_ATTACHMENTS_LINKS_' => ($user_prefs & _M2F_USER_ATTACHMENT_LINKS_) ? 'SELECTED' : '',
			'_M2F_ATTACHMENTS_ATTACH_' => (($user_prefs & _M2F_USER_IGNORE_ATTACHMENTS_)  or ($user_prefs & _M2F_USER_ATTACHMENT_LINKS_)) ? '' : 'SELECTED',
			'_M2F_USER_IMAGES_INLINE_YES' => ($user_prefs & _M2F_USER_IMAGES_INLINE_) ? 'SELECTED' : '',
			'_M2F_USER_IMAGES_INLINE_NO' => ($user_prefs & _M2F_USER_IMAGES_INLINE_) ? '' : 'SELECTED',
			'_M2F_USER_THUMBNAIL_IMAGES_YES' => ($user_prefs & _M2F_USER_THUMBNAIL_IMAGES_) ? 'SELECTED' : '',
			'_M2F_USER_THUMBNAIL_IMAGES_NO' => ($user_prefs & _M2F_USER_THUMBNAIL_IMAGES_) ? '' : 'SELECTED',
			'_M2F_USER_HTML_EMAIL_' => _M2F_USER_HTML_EMAIL_,
			'_M2F_USER_IGNORE_ATTACHMENTS_' => _M2F_USER_IGNORE_ATTACHMENTS_,
			'_M2F_USER_ATTACHMENT_LINKS_' => _M2F_USER_ATTACHMENT_LINKS_,
			'_M2F_USER_IMAGES_INLINE_' => _M2F_USER_IMAGES_INLINE_,
			'_M2F_USER_THUMBNAIL_IMAGES_' => _M2F_USER_THUMBNAIL_IMAGES_,
			'_M2F_MAX_USER_PREF_' => _M2F_MAX_USER_PREF_,
			) );



// Depending on what we need to do...
switch ($mode) {
  // ---------------------------------------------------------------------------------
  case 'usercp':
    if (isset($HTTP_POST_VARS['unsubscribe']) && is_array($HTTP_POST_VARS['unsub_mailinglist_id']))
    {
    	foreach ($HTTP_POST_VARS['unsub_mailinglist_id'] as $mailinglist_id)
    	{
      	$m2f_handler->m2f_mailinglist->delete_subscription($mailinglist_id, $userdata['user_id']);
      }
    }

    if (isset($HTTP_POST_VARS['subscribe']) && is_array($HTTP_POST_VARS['sub_mailinglist_id']))
    {
			foreach ($HTTP_POST_VARS['sub_mailinglist_id'] as $mailinglist_id)
    	{
				$distributionlist_details = $m2f_handler->get_distributionlist_details_from_mailinglist_id($mailinglist_id);
				$is_auth = auth(AUTH_READ, $distributionlist_details['forum_id'], $userdata);
				if ($is_auth['auth_read'] == 1)
				{
					$m2f_handler->m2f_mailinglist->new_subscription($mailinglist_id, $userdata['user_id']);
				}     
			}
    }
  break;
}

// Get subscribed mailinglists
$subscribed_mailinglists = $m2f_handler->get_subscribed_mailinglists($userdata['user_id']);

if (count($subscribed_mailinglists) != 0)
{
	$template->assign_block_vars('switch_current_subscriptions', array());
	foreach ($subscribed_mailinglists as $subscribed_mailinglist)
	{
		
		$template->assign_block_vars('switch_current_subscriptions.subscribed_mailinglists', array(
		'forum_name' => $subscribed_mailinglist['forum_name'],
		'mailinglist_name' => $subscribed_mailinglist['mailinglist_name'],
		'mailinglist_id' => $subscribed_mailinglist['mailinglist_id'],
		'mailinglist_address' => $subscribed_mailinglist['mailinglist_address']
		));
	}
}

$is_auth = auth(AUTH_READ, AUTH_LIST_ALL, $userdata);

// Get unsubscribed mailinglists
$unsubscribed_mailinglists = $m2f_handler->get_unsubscribed_mailinglists($userdata['user_id']);
$subscribed_mailinglists_with_group = $m2f_handler->get_subscribed_mailinglists_with_group($userdata['user_id']);

$already_subscribed_via_group  = array();
foreach ($subscribed_mailinglists_with_group as $array)
{
	$already_subscribed_via_group[] = $array['mailinglist_id'];
}

if (count($unsubscribed_mailinglists) != 0)
{
	foreach ($unsubscribed_mailinglists as $unsubscribed_mailinglist)
	{
		if (in_array($unsubscribed_mailinglist['mailinglist_id'], $already_subscribed_via_group)) continue;
		if ($is_auth[$unsubscribed_mailinglist['forum_id']]['auth_read'] == 1)
		{		
			if ($on!=TRUE)
			{
				$template->assign_block_vars('switch_new_subscriptions', array());
				$on = TRUE;
			}
			
			$template->assign_block_vars('switch_new_subscriptions.unsubscribed_mailinglists', array(
			'mailinglist_id' => $unsubscribed_mailinglist['mailinglist_id'],
			'forum_name' => $unsubscribed_mailinglist['forum_name'],
			'mailinglist_name' => $unsubscribed_mailinglist['mailinglist_name'],
			'mailinglist_address' => $unsubscribed_mailinglist['mailinglist_address']
			));
		}
	}
}

if (count($subscribed_mailinglists_with_group) != 0)
{
	$template->assign_block_vars('switch_current_subscriptions_group', array());
	foreach ($subscribed_mailinglists_with_group as $subscribed_mailinglist)
	{
		$template->assign_block_vars('switch_current_subscriptions_group.subscribed_mailinglists', array(
		'forum_name' => $subscribed_mailinglist['forum_name'],
		'group_name' => $subscribed_mailinglist['group_name'],
		'mailinglist_name' => $subscribed_mailinglist['mailinglist_name'],
		'mailinglist_address' => $subscribed_mailinglist['mailinglist_address']
		));
	}
}


if ($on!=TRUE)
{
	$template->assign_block_vars('switch_no_new_subscriptions', array());
}

// SID constant
$template->assign_vars(array('S_M2F_ACTION' => append_sid('m2f_usercp.' . $phpEx)));

// Output the template
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>